=== cmake/CMakeLists.txt ===
# Copyright 2009-present MongoDB, Inc.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

add_subdirectory(make_dist)

set(cmake_MODULES
    BsoncxxUtil.cmake
    FetchCatch2.cmake
    FetchMongoC.cmake
    MacroGuardTest.cmake
    MongocxxUtil.cmake
    ParseVersion.cmake
)

set_local_dist(cmake_DIST_local
    CMakeLists.txt
    ${cmake_MODULES}
)

set(cmake_DIST
    ${cmake_DIST_local}
    ${cmake_make_dist_DIST}
    PARENT_SCOPE
)
