=== debian/changelog ===
mongo-cxx-driver (4.1.4-1) experimental; urgency=medium

  * New upstream release
  * Bump dependency on libmongoc-dev
  * Update to debhelper compatibility 13

 -- Roberto C. Sanchez <roberto@connexer.com>  Wed, 08 Oct 2025 15:45:43 -0400
