=== debian/control ===
Source: mongo-cxx-driver
Priority: optional
Maintainer: Mongo C++ Driver Team <mongo-cxx-driver-debian@googlegroups.com>
Uploaders: Kevin Albertson <kevin.albertson@mongodb.com>,
           Roberto C. Sanchez <roberto@connexer.com>
Build-Depends: debhelper-compat (= 13),
               cmake,
               pkgconf,
               libmongoc-dev (>= 2.0.0),
               libsasl2-dev,
               libutf8proc-dev,
               doxygen
Standards-Version: 4.7.0
Section: libs
Homepage: https://mongocxx.org/
Vcs-Git: https://github.com/mongodb/mongo-cxx-driver.git
Vcs-Browser: https://github.com/mongodb/mongo-cxx-driver/tree/master

Package: libmongocxx-dev
Section: libdevel
Architecture: any
Depends: libmongocxx-noabi (= ${binary:Version}),
         libbsoncxx-dev (= ${binary:Version}),
         libssl-dev,
         zlib1g-dev,
         libsnappy-dev,
         libutf8proc-dev,
         ${misc:Depends}
Description: MongoDB C++ client library - dev files
 libmongocxx is the officially supported MongoDB client library for C++
 applications.
 .
 This package contains all files necessary to develop applications which
 use libmongocxx.

Package: libmongocxx-noabi
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: MongoDB C++ client library - runtime files
 libmongocxx is the officially supported MongoDB client library for C++
 applications.
 .
 This package contains the libmongocxx runtime libraries, for applications that
 have been built with libmongocxx.

Package: libmongocxx-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: MongoDB C++ client library - documentation
 libmongocxx is the officially supported MongoDB client library for C++
 applications.
 .
 This package contains the documentation for libmongocxx and libbsoncxx.

Package: libbsoncxx-dev
Section: libdevel
Architecture: any
Depends: libbsoncxx-noabi (= ${binary:Version}),
         ${misc:Depends}
Description: Library to parse and generate BSON documents - dev files
 libbsoncxx parses and generates BSON documents, the data format for
 MongoDB. It is a dependency for libmongocxx, the MongoDB client library,
 for which it provides BSON support as well as platform-compatibility
 functions and macros.
 .
 This package contains all files necessary to develop applications which
 use libbsoncxx.

Package: libbsoncxx-noabi
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Library to parse and generate BSON documents - runtime files
 libbsoncxx parses and generates BSON documents, the data format for
 MongoDB. It is a dependency for libmongocxx, the MongoDB client library,
 for which it provides BSON support as well as platform-compatibility
 functions and macros.
 .
 This package contains the libbsoncxx runtime libraries, for applications that
 have been built with libbsoncxx.
