=== debian/watch ===
version=4

opts="dversionmangle=s/\+dfsg[.\d]*//" \
https://github.com/mongodb/mongo-cxx-driver/releases /mongodb/mongo-cxx-driver/releases/download/\d\S*/mongo-cxx-driver-(\d\S*)\.tar\.gz
